#ifndef MSQL_ACCES_H
#define MSQL_ACCES_H
#include "data_acces.h"

#include <cppconn/driver.h>
#include <cppconn/exception.h>
#include <cppconn/resultset.h>
#include <cppconn/statement.h>
#include <cppconn/prepared_statement.h>

class msql_acces : public data_acces
{
public:
  static msql_acces* get_instance();
  static std::string user;
  static std::string pass;
  std::string get_passwd(std::string username);
  bool get_admin(std::string);
  std::list<std::string> get_pinfo();
  std::list<std::string> get_uinfo();
  void write_install(std::string package, std::string user);
  void write_remove(std::string);
  bool get_package_exists(std::string package);
  void create_user(std::string user, std::string pass, bool admin);
  void remove_user(std::string user);
private:
  msql_acces();
  static msql_acces* instance;
  sql::Connection *con;
  sql::Driver *driver;
};

#endif // MSQL_ACCES_H
